const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const warehouses = sequelize.define(
    'warehouses',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

warehouse_name: {
        type: DataTypes.TEXT,
      
      

      },

warehouse_code: {
        type: DataTypes.TEXT,
      
      

      },

warehouse_type: {
        type: DataTypes.ENUM,
      
      

        values: [

"raw_materials",


"wip",


"finished_goods",


"spares",


"quarantine"

        ],

      },

status: {
        type: DataTypes.ENUM,
      
      

        values: [

"active",


"inactive"

        ],

      },

notes: {
        type: DataTypes.TEXT,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  warehouses.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity









    db.warehouses.hasMany(db.storage_locations, {
      as: 'storage_locations_warehouse',
      foreignKey: {
          name: 'warehouseId',
      },
      constraints: false,
    });
















    db.warehouses.hasMany(db.inventory_lots, {
      as: 'inventory_lots_warehouse',
      foreignKey: {
          name: 'warehouseId',
      },
      constraints: false,
    });


    db.warehouses.hasMany(db.inventory_transactions, {
      as: 'inventory_transactions_from_warehouse',
      foreignKey: {
          name: 'from_warehouseId',
      },
      constraints: false,
    });

    db.warehouses.hasMany(db.inventory_transactions, {
      as: 'inventory_transactions_to_warehouse',
      foreignKey: {
          name: 'to_warehouseId',
      },
      constraints: false,
    });












//end loop



    db.warehouses.belongsTo(db.plants, {
      as: 'plant',
      foreignKey: {
        name: 'plantId',
      },
      constraints: false,
    });




    db.warehouses.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.warehouses.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return warehouses;
};


